Loading...
Searching...
No Matches
rate_ctr.c File Reference
Rate counters
`#include <stdbool.h>`
`#include <stdint.h>`
`#include <string.h>`
`#include <osmocom/core/utils.h>`
`#include <osmocom/core/linuxlist.h>`
`#include <osmocom/core/talloc.h>`
`#include <osmocom/core/timer.h>`
`#include <osmocom/core/rate_ctr.h>`
`#include <osmocom/core/logging.h>`

## Functions

static | LLIST_HEAD (rate_ctr_groups)
static bool | rate_ctrl_group_desc_validate (const struct rate_ctr_group_desc *desc)
static char * | mangle_identifier_ifneeded (const void *ctx, const char *in)
static struct rate_ctr_group_desc * | rate_ctr_group_desc_mangle (void *ctx, const struct rate_ctr_group_desc *desc)
static unsigned int | rate_ctr_get_unused_name_idx (const char *name)
| Find an unused index for this rate counter group.
struct rate_ctr_group * | rate_ctr_group_alloc (void *ctx, const struct rate_ctr_group_desc *desc, unsigned int idx)
| Allocate a new group of counters according to description.
void | rate_ctr_group_free (struct rate_ctr_group *grp)
| Free the memory for the specified group of counters.
struct rate_ctr * | rate_ctr_group_get_ctr (struct rate_ctr_group *grp, unsigned int idx)
| Get rate counter from group, identified by index idx.
void | rate_ctr_group_set_name (struct rate_ctr_group *grp, const char *name)
| Set a name for the group of counters be used instead of index value at report time.
void | rate_ctr_add (struct rate_ctr *ctr, int inc)
| Increment the counter by inc.
int64_t | rate_ctr_difference (struct rate_ctr *ctr)
| Return the counter difference since the last call to this function.
static void | interval_expired (struct rate_ctr *ctr, enum rate_ctr_intv intv)
static void | rate_ctr_group_intv (struct rate_ctr_group *grp)
static void | rate_ctr_timer_cb (void *data)
int | rate_ctr_init (void *tall_ctx)
| Initialize the counter module.
struct rate_ctr_group * | rate_ctr_get_group_by_name_idx (const char *name, const unsigned int idx)
| Search for counter group based on group name and index.
const struct rate_ctr * | rate_ctr_get_by_name (const struct rate_ctr_group *ctrg, const char *name)
| Search for counter based on group + name.
int | rate_ctr_for_each_counter (struct rate_ctr_group *ctrg, rate_ctr_handler_t handle_counter, void *data)
| Iterate over each counter in group and call function.
int | rate_ctr_for_each_group (rate_ctr_group_handler_t handle_group, void *data)
| Iterate over all counter groups.
void | rate_ctr_reset (struct rate_ctr *ctr)
| Reset a rate counter back to zero.
void | rate_ctr_group_reset (struct rate_ctr_group *ctrg)
| Reset all counters in a group.

## Variables

static void * | tall_rate_ctr_ctx
static struct osmo_timer_list | rate_ctr_timer
static uint64_t | timer_ticks